
#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>
#include "statsme.h"

static char pList[1024];
player_t	players[33];
announce_t	score;
motd_t*		sm_motd;
action_t*	sm_menu;
action_t *	sm_alias;
task_t*		sm_task;

void ServerActivate_Post( edict_t *pEdictList, int edictCount, int clientMax )
{
	memset(players,0,sizeof(players));
	memset(score.roundstats,0,sizeof(score.roundstats));
	memset(score.gamestats,0,sizeof(score.gamestats));
	
	for(int i =0; i< score.team_num; ++i){
		score.roundstats[i].name = score.gamestats[i].name = score.team_name[i];
		score.gamestats[i].switcher = 3;
	}

	score.c4_planting = 0;
	score.c4_timing = 0;
	score.c4_timer = 0;
	score.bomber = NULL;
	score.defuser = NULL;
	score.killer = NULL;
	score.victim = NULL;
	score.player = NULL;
	score.stats_endround = 0;	;
	score.endround_type = 0;
	score.stats_endmap = 0;
	score.stats_kill = 0;
	score.game_timeleft = 0;
	score.game_restarting = 0;
	score.team_num = 0;
	score.task_time = 0;

	time_t currenttime; time(&currenttime); //get current time
	if (difftime(currenttime,score.last_save) > ((int)sm_resetrank->value * 3600)) {
		memset(&rank,0,sizeof(rank)); //reset stats it time has been reached
		time(&score.last_save); //save time of this reset
	}

	if (gmsgCurWeapon) { // do init below only once
		RETURN_META(MRES_IGNORED);
	}

	gmsgCurWeapon	=	GET_USER_MSG_ID(PLID, "CurWeapon", NULL );
	gmsgDamage		=	GET_USER_MSG_ID(PLID, "Damage", NULL );
	gmsgDeathMsg	=	GET_USER_MSG_ID(PLID, "DeathMsg", NULL );
	gmsgTextMsg		=	GET_USER_MSG_ID(PLID, "TextMsg", NULL );
	gmsgWeapPickup	=	GET_USER_MSG_ID(PLID, "WeapPickup", NULL );
	gmsgTeamInfo	=	GET_USER_MSG_ID(PLID, "TeamInfo", NULL );
	gmsgWeaponList	=	GET_USER_MSG_ID(PLID, "WeaponList", NULL );
	gmsgResetHUD	=   GET_USER_MSG_ID(PLID, "ResetHUD", NULL );
	gmsgMOTD		=	GET_USER_MSG_ID(PLID, "MOTD", NULL );
	gmsgServerName	=	GET_USER_MSG_ID(PLID, "ServerName", NULL );
	gmsgHealth		=	GET_USER_MSG_ID(PLID, "Health", NULL);
	gmsgBattery		=	GET_USER_MSG_ID(PLID, "Battery", NULL);
	gmsgShowMenu	=	GET_USER_MSG_ID(PLID, "ShowMenu", NULL);
	gmsgSendAudio	=	GET_USER_MSG_ID(PLID, "SendAudio", NULL);
	gmsgTeamScore	=	GET_USER_MSG_ID(PLID, "TeamScore", NULL);
	gmsgMoney		=	GET_USER_MSG_ID(PLID, "Money", NULL);
	gmsgAmmoX		=	GET_USER_MSG_ID(PLID, "AmmoX", NULL);

	for(int a=0,size=0; a < MAX_REG_MSGS; ++a){
		const char *cp=GET_USER_MSG_NAME(PLID, a, &size);
		if(cp && !strcmp("intermission?",cp)){
			gmsgintermission = a;
			break;
		}
	}

	// Set proper calls for Engine Messages Parses
	memset(modMsgs,NULL,sizeof(modMsgs));
	memset(modMsgEnds,NULL,sizeof(modMsgEnds));
	modMsgs[gmsgCurWeapon].modMsgFunction = Client_CurWeapon;
	modMsgs[gmsgDamage].modMsgFunction = Client_Damage;
	modMsgs[gmsgDeathMsg].modMsgFunction = Client_DeathMsg;
	modMsgs[gmsgTextMsg].modMsgFunction = Client_TextMsg;
	modMsgs[gmsgWeapPickup].modMsgFunction = Client_WeapPickup;
	modMsgs[gmsgTeamInfo].modMsgFunction = Client_TeamInfo;
	modMsgs[gmsgWeaponList].modMsgFunction = Client_WeaponList;
	modMsgs[gmsgMOTD].modMsgFunction = Client_CurWeapon;
	modMsgs[gmsgHealth].modMsgFunction = Client_Health;
	modMsgs[gmsgBattery].modMsgFunction = Client_Battery;
	modMsgs[gmsgShowMenu].modMsgFunction = Client_ShowMenu;
	modMsgs[gmsgSendAudio].modMsgFunction = Client_SendAudio;
	modMsgs[gmsgTeamScore].modMsgFunction = Client_TeamScore;
	modMsgs[gmsgMoney].modMsgFunction = Client_Money;
	modMsgs[gmsgAmmoX].modMsgFunction = Client_AmmoX;
	modMsgEnds[gmsgintermission].modMsgFunction = Client_intermission;
	modMsgEnds[gmsgResetHUD].modMsgFunction = Client_ResetHUD;

	mp_timelimit=CVAR_GET_POINTER("mp_timelimit");

	RETURN_META(MRES_IGNORED);
}

void ServerDeactivate( void ) {
	for (int a = 1; a <= gpGlobals->maxClients; ++a){		
		player_t *pPlayer = GET_PLAYER_POINTER_I(a);
		if (pPlayer->valid && !pPlayer->stats_sent)	{
			pPlayer->stats_sent = true;
			AddPlayerToRank(pPlayer);
		}
	}
	//clear adminmod plugin calls
	for(int i=0; i < MAX_REG_MSGS ; i++)	{
		if (!modMsgFunCalls[i])
			continue;
		fun_call_t*start = modMsgFunCalls[i];
		fun_call_t*next = start;
		while (next){
			start = start->next;
			delete[] next->cmd;
			cond_t*cpnext = next->cond;
			cond_t*cp = cpnext;
			while(cp){ //delete all conditions from fun_call_t
				cpnext = cpnext->next;
				delete[] cp->toval;
				delete cp;
				cp = cpnext;
			}
			delete next;
			next = start;
		}
		modMsgFunCalls[i] = NULL;
	}
	//clear motd
	motd_t*start=sm_motd;
	motd_t*next=start;
	while(next){
		start = start->next;
		delete[] next->msg;
		delete next;
		next = start;
	}
	sm_motd = NULL;
	//clear menu
	action_t*start_m=sm_menu;
	action_t*next_m=start_m;
	while(next_m){
		start_m = start_m->next;
		delete[] next_m->name;
		delete[] next_m->cmd;
		delete next_m;
		next_m = start_m;
	}
	sm_menu= NULL;
	//clear aliases
	action_t*start_a=sm_alias;
	action_t*next_a=start_a;
	while(next_a){
		start_a = start_a->next;
		delete[] next_a->name;
		delete[] next_a->cmd;
		delete next_a;
		next_a = start_a;
	}
	sm_alias= NULL;

	//clear tasks
	task_t*start_t=sm_task;
	task_t*next_t=start_t;
	while(next_t){
		start_t = start_t->next;
		delete[] next_t->cmd;
		delete next_t;
		next_t = start_t;
	}
	sm_task= NULL;

	RETURN_META(MRES_IGNORED);
}

char* GetFightList(player_t *pPlayer, bool attackers)
{
	bool changed = false;
	int len = 1, id = pPlayer->index;
	player_t* pLastK = pPlayer->killer;
	player_t* pLastV = pPlayer->victim;
	for (int a = 1; a <= gpGlobals->maxClients; ++a)
	{
		if (attackers)
		{
			if ( players[a].ingame && players[a].specstats[id].hits )
			{
				changed = true;
				
				pPlayer->killer = &players[a];
				
				pPlayer->killer->custom_stats = &players[a].specstats[id];
				
				len += sprintf(&pList[len], UTIL_FillWithVars( sm_attackersbody->string )  );
				
				pList[len-1] = '\\'; pList[len] = 'n'; pList[++len] = 0; //small hack
			}	
		}
		else
		{
			if ( pPlayer->specstats[a].hits )
			{
				changed = true;
				
				pPlayer->victim = &players[a];
				
				pPlayer->custom_stats = &pPlayer->specstats[a];
				
				len += sprintf(&pList[len], UTIL_FillWithVars( sm_victimsbody->string )  );
				
				pList[len-1] = '\\'; pList[len] = 'n'; pList[++len] = 0;				
			}	
		}
	}
	pPlayer->killer = pLastK;
	pPlayer->victim = pLastV;
	return ( changed ? (pList + 1) : (char*)"0");
}

void PlayerPreThink_Post( edict_t *pEntity ) 
{
	int id = ENTINDEX(pEntity);

	player_t *pPlayer = GET_PLAYER_POINTER_I(id);

	// latency measure - thx to PsychoGuard
    if (pPlayer->latency_time > 0 && pPlayer->latency_time < gpGlobals->time)
	{	
		pPlayer->latency_time = gpGlobals->time + (int)sm_latlogfreq->value;

		int ping, packet_loss;

		PLAYER_CNX_STATS(pPlayer->pEdict, &ping, &packet_loss);

		if (ping > 0) 
		{
			pPlayer->latency_sum += ping;
			pPlayer->latency_samples++;
		}
	}

	// if this is after kill then check for monster kill!
	if (pPlayer->monster_time > 0 && pPlayer->monster_time < gpGlobals->time)
	{
		pPlayer->monster_time = 0;

		if ( SM_MODE(MONSTER_ON) && *sm_monsterkill->string && pPlayer->monster.kills >= sm_monsterkillnum->value )
		{
			score.player = pPlayer;

			pPlayer->custom_stats = &pPlayer->monster;

			SERVER_COMMAND( UTIL_FillWithVars( sm_monsterkill->string ) );
		}
	}

	// Victim and Attacker list
	if (pPlayer->stats_time > 0 && pPlayer->stats_time < gpGlobals->time)	
	{
		pPlayer->stats_time = -1; // set to -1 so we won't have displayed stats again at round end

		score.player = pPlayer;

		if ( SM_MODE(AL_ON) && *sm_attackers->string) // Attackers
		{ 
			char* sList = UTIL_FillWithVars( sm_attackers->string );
			if (sList && *sList)
			{
				if (score.stats_flags & ROUND_END) // this is caused by round end so make with delay
					TASK_COMMAND( sList, gpGlobals->time + sm_roundenddelay->value,0 );
				else
					SERVER_COMMAND( sList );
			}
		}
		
		if ( SM_MODE(VL_ON) && *sm_victims->string) //Victims	
		{
			char* sList = UTIL_FillWithVars(sm_victims->string);
			if (sList && *sList)
			{
				if (score.stats_flags & ROUND_END) // this is caused by round end so make with delay
					TASK_COMMAND( sList , gpGlobals->time + sm_roundenddelay->value,0 );
				else
					SERVER_COMMAND( sList );
			}
		}
	}

	// delayed menu (while statsme menu using)
	if (pPlayer->menu_time > 0 && pPlayer->menu_time < gpGlobals->time)
	{
		pPlayer->menu_time = 0;
		StatsMeMenu(pPlayer, pPlayer->menu_state);
	}

	RETURN_META(MRES_IGNORED);
}

// Fill vars with player stats and all weapon stats
char* MakeStats(player_t *pPlayer, char* pList)
{
	*pList = 0; score.player = pPlayer;
	// fill sm_playerstats with collected data
	int len = sprintf(pList,UTIL_FillWithVars(sm_playerstats->string));
	for (int i = 0; i < MAX_WEAPONS ; ++i)	{	// specified for each weapon
		if ( pPlayer->wpnstats[i].hits || pPlayer->wpnstats[i].shots ) { //pistols and white weapon
			pPlayer->custom_stats = &pPlayer->wpnstats[i];
			len+=sprintf(&pList[len],UTIL_FillWithVars(sm_weaponstats->string));
		}
	}

	return pList;
}

void StartFrame_Post( void )
{
	// announcement with delay
	if (score.task_time < gpGlobals->time)
	{
		score.task_time = gpGlobals->time + 1.0; // check every 1.0 sec.

		bool alldone = true;

		for (task_t *p = sm_task; p ; p = p->next )
		{
			if ( !p->time ) continue; //skip done
				
			if ( p->time > gpGlobals->time ) {//skip and not ready
				alldone = false; //mark that this list is still tasked
				continue;
			}

			if (p->cmd && *p->cmd) SERVER_COMMAND( p->cmd );

			p->time = (p->flags&1) ? (gpGlobals->time + p->repeat) : 0; //mark as done
		}

		if (sm_task && alldone) // clear tasks if any
		{
			task_t*start_t=sm_task;
			task_t*next_t=start_t;
			while(next_t){
				start_t = start_t->next;
				delete[] next_t->cmd;
				delete next_t;
				next_t = start_t;
			}
			sm_task= NULL;
		}
	}

	// reset start on restart or game commencing
	if ( score.game_restarting > 0 && score.game_restarting < gpGlobals->time )
	{
		score.game_restarting = 0;

		if ( sm_resetonrestart->value )
		{
			for(int i = 1; i <= gpGlobals->maxClients; ++i )
			{	
				player_t *pPlayer = GET_PLAYER_POINTER_I(i);
				memset(pPlayer->wpnstats,0,sizeof(pPlayer->wpnstats));
				memset(&pPlayer->gamestats,0,sizeof(pPlayer->gamestats));
				memset(&pPlayer->roundstats,0,sizeof(pPlayer->roundstats));
				memset(pPlayer->specstats,0,sizeof(pPlayer->specstats));
				memset(&pPlayer->monster,0,sizeof(pPlayer->monster));
			}

			score.c4_timer = 0;

			memset(score.roundstats,0,sizeof(score.roundstats));
			memset(score.gamestats,0,sizeof(score.gamestats));
			
			for(int a =0; a< score.team_num; ++a){
				score.roundstats[a].name = score.gamestats[a].name = score.team_name[a];
				score.gamestats[a].switcher = 3;
			}
		}
	}

	// bomb counting down
	if (score.c4_timer > 0 && score.c4_timing < gpGlobals->time)
	{
		score.c4_timing = gpGlobals->time + 1.0; // next check on next second

		--score.c4_timer;

		int freq = sm_bombfreq->value ? sm_bombfreq->value : 1; //exclude divide by 0

		if ( score.c4_timer <= sm_bombcont->value || !( score.c4_timer % freq ) )
		{
			if ( *sm_bombtimefreq->string || *sm_bombtimecont->string )
				SERVER_COMMAND( UTIL_FillWithVars( ( score.c4_timer <= sm_bombcont->value ) ? 
					sm_bombtimecont->string : sm_bombtimefreq->string ) );
		}
	}

	// some events on kill
	if (score.stats_kill > 0 && score.stats_kill < gpGlobals->time)	
	{
		score.stats_kill = 0;

		if ( SM_MODE(STAB_ON) && *sm_knifekill->string && ( score.stats_flags & KNIFE_KILL )  ) //knife kill
			SERVER_COMMAND(UTIL_FillWithVars(sm_knifekill->string));
		
		if ( SM_MODE(HEAD_ON) && *sm_headshot->string && ( score.stats_flags & HS_KILL ) ) //headshot kill
			SERVER_COMMAND(UTIL_FillWithVars(sm_headshot->string));
		
		if ( SM_MODE(KILL_ON) && *sm_kill->string )  //normal kill
			SERVER_COMMAND(UTIL_FillWithVars(sm_kill->string));
	}

	// end round stats
	if (score.stats_endround > 0 && score.stats_endround < gpGlobals->time)	
	{
		score.stats_endround = 0;

		// get guy with highest score or if has the same score then take with more headshots
		for (int a = 1; a <= gpGlobals->maxClients ; ++a) 
		{
			player_t *pPlayer = GET_PLAYER_POINTER_I(a);

			if (!pPlayer->ingame || pPlayer->stats_time == -1) continue;
			
			// display victims and attackers lists
			pPlayer->stats_time = gpGlobals->time + 0.02;
		}

		if (SM_MODE(ROUND_ON) && *sm_roundend->string)
		{
			char* todo = UTIL_FillWithVars(sm_roundend->string);
			if (todo && *todo ) TASK_COMMAND( todo , gpGlobals->time + sm_roundenddelay->value,0 );
		}
		if (SM_MODE(BDWS_ON) && *sm_bombdefused->string && score.endround_type == 1)
		{
			SERVER_COMMAND( UTIL_FillWithVars( sm_bombdefused->string ) );
		}
		else if (SM_MODE(BDF_ON) && *sm_bombfailure->string && score.endround_type == 2 && score.defuser)
		{
			SERVER_COMMAND( UTIL_FillWithVars( sm_bombfailure->string ) );
		}

		memset(score.roundstats,0,sizeof(score.roundstats)); //reset round stats
		
		for(int i =0; i< score.team_num; ++i){
			score.roundstats[i].name = score.gamestats[i].name = score.team_name[i];
			score.gamestats[i].switcher = 3;
		}

		score.endround_type = 0;
		score.defuser = NULL;
		score.bomber = NULL;
	}

	// intermission is on and delay has been achived - show stats to all players
	if (score.stats_endmap > 0 && score.stats_endmap < gpGlobals->time)	
	{
		score.stats_endmap = 0.0;

		if ( SM_MODE(SCORE_ON) )
		{
			for (int a = 1; a <= gpGlobals->maxClients; ++a)
			{		
				player_t *pPlayer = GET_PLAYER_POINTER_I(a);

				if (pPlayer->valid)
				{
					UTIL_ShowMOTD(pPlayer->pEdict,MakeStats(pPlayer,pList), STRING( pPlayer->pEdict->v.netname ));	
				}
			}
		}
	}	

	RETURN_META(MRES_IGNORED);
}

BOOL ClientConnect_Post( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{
	int index = ENTINDEX(pEntity);
	player_t* pPlayer = score.player = GET_PLAYER_POINTER_I(index);
	pPlayer->pEdict = pEntity;
	pPlayer->index = index;
	pPlayer->play_time = gpGlobals->time; //start time like original "status"
	pPlayer->valid = false;
	pPlayer->ingame	= false;
	pPlayer->team_name[0] = 0;
	pPlayer->team_index = 0;
	pPlayer->ip[0] = 0;
	pPlayer->monster_time = 0;

	pPlayer->health = 0;
	pPlayer->armor = 0;
	pPlayer->money = 0;

	pPlayer->menu_id = 0;
	pPlayer->menu_type = MENU_IDLE;
	pPlayer->menu_keys = 0;
	pPlayer->menu_state = 0;
	pPlayer->menu_time = 0.0;
	pPlayer->menu_pplnum = 0;	//number of players in menu list

	pPlayer->grenade = NULL;
	pPlayer->grenade_time = 0.0;

	pPlayer->latency_sum = 0;
	pPlayer->latency_samples = 0;
	pPlayer->latency_time = 0.0;

	memset(pPlayer->menu_list,NULL,sizeof(pPlayer->menu_list));
	memset(&pPlayer->monster,0,sizeof(pPlayer->monster));
	memset(&pPlayer->gamestats,0,sizeof(pPlayer->gamestats));
	memset(&pPlayer->roundstats,0,sizeof(pPlayer->roundstats));
	memset(pPlayer->specstats,0,sizeof(pPlayer->specstats));
	memset(pPlayer->wpnstats,0,sizeof(pPlayer->wpnstats));

	pPlayer->custom_stats = NULL;
	pPlayer->weapon = NULL;

	pPlayer->aiming_at = 0;
	pPlayer->wpnid = 0;

	pPlayer->killer = NULL;				// last your killer
	pPlayer->victim = NULL;				// last your victim

	pPlayer->stats_time	= -1;
	pPlayer->stats_sent = false;
	pPlayer->stats_enabled = false;

	strcpy(pPlayer->ip, pszAddress ); //save ip address of this player

	if ( sm_motd )
	{
		for( motd_t*p = sm_motd ;p;p=p->next)
		{
			char* echo_motd = UTIL_FillWithVars(p->msg);

			if ( !echo_motd || !echo_motd[0] )	continue; //SKIP! function used or just null string

			CLIENT_COMMAND(pEntity,echo_motd);
		}
	}

	RETURN_META_VALUE(MRES_IGNORED, TRUE);
}

void ClientDisconnect( edict_t *pEntity ) 
{
	player_t *pPlayer = score.player = GET_PLAYER_POINTER(pEntity);

	//Go through weapons stats and log only fired/used weapons
	for (int i = 0; i < MAX_WEAPONS ; ++i)	
	{
		if (pPlayer->wpnstats[i].shots) 
		{
			pPlayer->custom_stats = &pPlayer->wpnstats[i];

			UTIL_LogPrintf("\"%s<%i><%u><%s>\" triggered \"weaponstats\" %s",
				STRING( pEntity->v.netname ), 	GETPLAYERUSERID( pEntity ),
				GETPLAYERWONID( pEntity ),	pPlayer->team_name,
				UTIL_FillWithVars(sm_logformat->string));

			UTIL_LogPrintf("\"%s<%i><%u><%s>\" triggered \"weaponstats2\" %s",
				STRING( pEntity->v.netname ), 	GETPLAYERUSERID( pEntity ),
				GETPLAYERWONID( pEntity ),	pPlayer->team_name,
				UTIL_FillWithVars(sm_logformat2->string));
		}
	}
		
	if (pPlayer->latency_samples > 0) 
	{
	    UTIL_LogPrintf("\"%s<%i><%u><%s>\" triggered \"latency\" %s",
			   STRING(pPlayer->pEdict->v.netname),   GETPLAYERUSERID(pPlayer->pEdict),
			   GETPLAYERWONID(pPlayer->pEdict),   pPlayer->team_name,
			   UTIL_FillWithVars(sm_latlogformat->string));
	}

	if ( sm_timelogformat->string[0] ) 
	{
		UTIL_LogPrintf("\"%s<%i><%u><%s>\" triggered \"time\" %s",
			STRING(pPlayer->pEdict->v.netname),	GETPLAYERUSERID(pPlayer->pEdict),
			GETPLAYERWONID(pPlayer->pEdict),	pPlayer->team_name,
			UTIL_FillWithVars(sm_timelogformat->string));
	}

	if (!pPlayer->stats_sent)
	{
		pPlayer->stats_sent = true;
		AddPlayerToRank(pPlayer);
	}

	pPlayer->valid = false;
	pPlayer->ingame	= false;

	RETURN_META(MRES_IGNORED);
}

void ClientPutInServer_Post( edict_t *pEntity ) 
{
	player_t *pPlayer		= score.player = GET_PLAYER_POINTER(pEntity);
	pPlayer->valid			= ( GETPLAYERWONID(pEntity) > 0 ) ? true : false;
	pPlayer->ingame			= true;
	pPlayer->stats_enabled	= true;
	pPlayer->latency_time	= (*sm_latlogformat->string&&sm_latlogfreq->value)?(gpGlobals->time+sm_latlogfreq->value):0;

	RETURN_META(MRES_IGNORED);
}

void ClientCommand( edict_t *pEntity )
{
	player_t *pPlayer = score.player = GET_PLAYER_POINTER(pEntity);

	const char* cmds = CMD_ARGV(0); 
	const char* said = CMD_ARGV(1);

	if (!strcmp(cmds,"say") || !strcmp(cmds,"say_team")){

		if (SM_MODE(TOP_ON)&&!strcmp(said,sm_rankcmd->string)){// top15
			ShowTopScore(pPlayer);
			RETURN_META(MRES_IGNORED);
		}
		if (SM_MODE(STATS_ON)&&!strcmp(said,sm_statsmecmd->string)){ // statsme
			UTIL_ShowMOTD(pEntity, MakeStats(pPlayer,pList) , STRING( pEntity->v.netname ));
			RETURN_META(MRES_IGNORED);
		}
		if (SM_MODE(STATS_ON)&&!strcmp(said,sm_statscmd->string)){ // stats
			StatsMenu(pPlayer, 0);
			RETURN_META(MRES_IGNORED);
		}		
		if (!strcmp(said,sm_switchcmd->string)){ //switch
			if (pPlayer->stats_enabled) {
				pPlayer->stats_enabled = false;
				UTIL_ClientPrint(pEntity,HUD_PRINTTALK,"* You will no longer see/hear statsme announcements.\n");
			}
			else {
				pPlayer->stats_enabled = true;
				UTIL_ClientPrint(pEntity,HUD_PRINTTALK, "* You have enabled statsme announcements.\n");
			}
			RETURN_META(MRES_IGNORED);
		}
		for (action_t*p=sm_alias;p;p=p->next){
			if (p->flags & 1) continue; //don't accept if alias have flag "a" - alias for console
			if ( strcmpi(p->name, said ) ) 	continue; //search for matching cmd
			char*cmdtodo = UTIL_FillWithVars( p->cmd );
			if ( cmdtodo && *cmdtodo ) SERVER_COMMAND( cmdtodo );
			if (p->flags & 4) //flag "c" makes that this alias (as say command) can't be said by player
				RETURN_META(MRES_SUPERCEDE);
			else
				RETURN_META(MRES_IGNORED);	
		}
	}
	else if ( (pPlayer->menu_type != MENU_IDLE) && !strcmp( cmds, "menuselect" ) )
	{
		int pressed_key = atoi(said);

		if ( ! ( pPlayer->menu_keys & ( 1 << (pressed_key - 1) ) ) )
			RETURN_META(MRES_SUPERCEDE); //don't allow to use menuselect x command when not available by slots
		
		if (pPlayer->menu_type == STATS_MENU)	{ // menu
			int begin_select = (pPlayer->menu_state*8);
			switch(pressed_key){
			case 9:
				StatsMenu(pPlayer, pPlayer->menu_state+1);
				break;
			case 10:
				StatsMenu(pPlayer, pPlayer->menu_state-1);		
				break;
			default:
				begin_select += (pressed_key-1);
				UTIL_ShowMOTD(pEntity,MakeStats(pPlayer->menu_list[begin_select],pList),
					STRING(pPlayer->menu_list[begin_select]->pEdict->v.netname ));
				StatsMenu(pPlayer, pPlayer->menu_state);
			}
		}
		else if (pPlayer->menu_type == STATSME_MENU)	{
			int begin_select = (pPlayer->menu_state*8);
			switch(pressed_key){
			case 9:
				StatsMeMenu(pPlayer, pPlayer->menu_state+1);
				break;
			case 10:
				StatsMeMenu(pPlayer, pPlayer->menu_state-1);		
				break;
			default:{
				begin_select += (pressed_key-1);
				action_t*a=sm_menu;
				for(int c = 0;c<begin_select;c++) a=a->next;
				SERVER_COMMAND(UTIL_FillWithVars(a->cmd));
				pPlayer->menu_time = gpGlobals->time + 0.2; //doh - we must use here delay
				}
			}
		}
		else if (pPlayer->menu_type == MENU_STANDARD)	{
			if (sm_logmenuaction->value) 
				UTIL_LogPrintf("\"%s<%i><%u><%s>\" triggered \"menu_answer\" (menu \"%d\") (option \"%d\")\n",
					STRING( pEntity->v.netname ), GETPLAYERUSERID( pEntity ),
					GETPLAYERWONID( pEntity ), pPlayer->team_name,pPlayer->menu_id,pressed_key);
			pPlayer->menu_type=MENU_IDLE;
		}
		RETURN_META(MRES_SUPERCEDE);
	}
	else if (!strcmp(cmds,"statsme_menu") && *sm_menupassword->string && !strcmp(sm_menupassword->string,said))	{
		StatsMeMenu(pPlayer, 0);
		RETURN_META(MRES_SUPERCEDE);
	}
	for (action_t*p=sm_alias;p;p=p->next){
		if (p->flags & 2) continue; //don't accept if alias have flag "b" - alias for say
		if ( strcmpi(p->name, cmds ) ) continue; //search for matching cmd
		char*cmdtodo = UTIL_FillWithVars( p->cmd );
		if ( cmdtodo && *cmdtodo ) SERVER_COMMAND( cmdtodo );
		RETURN_META(MRES_SUPERCEDE);
	}


	RETURN_META(MRES_IGNORED);
}

DLL_FUNCTIONS gFunctionTable_Post;
C_DLLEXPORT int GetEntityAPI2_Post( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ) {
	gFunctionTable_Post.pfnClientConnect = ClientConnect_Post;
	gFunctionTable_Post.pfnClientPutInServer = ClientPutInServer_Post;
	gFunctionTable_Post.pfnServerActivate = ServerActivate_Post;
	gFunctionTable_Post.pfnPlayerPreThink = PlayerPreThink_Post;
	gFunctionTable_Post.pfnStartFrame = StartFrame_Post;
	memcpy( pFunctionTable, &gFunctionTable_Post, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

DLL_FUNCTIONS gFunctionTable;
C_DLLEXPORT int GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ){
	gFunctionTable.pfnClientDisconnect = ClientDisconnect;
	gFunctionTable.pfnClientCommand = ClientCommand;
	gFunctionTable.pfnServerDeactivate = ServerDeactivate;
	memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

// Must provide at least one of these..
META_FUNCTIONS gMetaFunctionTable = {
	NULL,					// pfnGetEntityAPI				HL SDK; called before game DLL
	NULL,					// pfnGetEntityAPI_Post			META; called after game DLL
	GetEntityAPI2,			// pfnGetEntityAPI2				HL SDK2; called before game DLL
	GetEntityAPI2_Post,		// GetEntityAPI2_Post,			// pfnGetEntityAPI2_Post		META; called after game DLL
	NULL,					// pfnGetNewDLLFunctions		HL SDK2; called before game DLL
	NULL,					// GetNewDLLFunctions_Post,	// pfnGetNewDLLFunctions_Post	META; called after game DLL
	GetEngineFunctions,		// pfnGetEngineFunctions		META; called before HL engine
	GetEngineFunctions_Post	// pfnGetEngineFunctions_Post	META; called after HL engine
};