

#include <stdio.h>
#include <stdarg.h>

#include <extdll.h>

#include "engine_api.h"
#include "meta_api.h"
#include "statsme.h"

int	gmsgCurWeapon=0;
int	gmsgDeathMsg;
int	gmsgDamage;
int	gmsgTextMsg;
int	gmsgWeapPickup;
int	gmsgTeamInfo;
int	gmsgWeaponList;
int	gmsgResetHUD;
int	gmsgintermission;
int gmsgMOTD;
int gmsgServerName;
int gmsgHealth;
int gmsgAmmoX;
int gmsgBattery;
int gmsgShowMenu;
int gmsgSendAudio;
int gmsgTeamScore;
int gmsgMoney;

fun_call_t*	modMsgFunCalls[MAX_REG_MSGS ];
fun_call_t*	modMsgHaveFun;
fun_me_t modMsgEnds[MAX_REG_MSGS ];
fun_me_t modMsgs[MAX_REG_MSGS ];
bool modMsgToRun;
void (*modMsgFunction)(void*);
void (*modMsgEndFunction)(void*);
player_t* modMsgPlayer;
char modMsgCmd[512];
int	 modMsgLen;
int modValIter;
int modMsgiTarget;
int	modMsgState;

struct quotes_t{const char *sInt, *sFloat, *sStr ;};
quotes_t wqts = {"\"%d\" ","\"%.4f\" ","\"%s\" "};
quotes_t woqts = {"%d ","%.4f ","%s "};
quotes_t* modFrm;

void MessageBegin_Post(int msg_dest, int msg_type, const float *pOrigin, edict_t *ed) {
	if (ed){
		modMsgiTarget = ENTINDEX(ed);
		modMsgPlayer = score.player = GET_PLAYER_POINTER_I(modMsgiTarget);
	} else {
		modMsgiTarget = 0;
		modMsgPlayer = NULL;
	}
	modMsgState	= 0;
	modValIter = 0;
	modMsgEndFunction=modMsgEnds[msg_type].modMsgFunction; //engine message parser call here for sm
	modMsgFunction=modMsgs[msg_type].modMsgFunction; //engine messsage parser call here for sm
	modMsgHaveFun=modMsgFunCalls[msg_type]; //am plugins calls which are registered with sm_register
	if (modMsgHaveFun){ //if there is any am plugin call
		modMsgToRun = true;
		fun_call_t*p;
		for(p=modMsgHaveFun;p;p=p->next){ //go through all and check if they are for specified player or for world msg
			if ( modMsgPlayer ? p->world : p->player ) { //if it's specified msg and am call marked for glob then skip and viceversa
				p->done = true;
				continue;
			}
			if ( p->once && p->stamp == (float)gpGlobals->time ){ //can be executed only once?
				p->done = true;
				continue;
			}
		}
		for(p=modMsgHaveFun;p;p=p->next){
			if (p->done) continue; //find first am call which have to be called
			modFrm=p->quotes?&wqts:&woqts;
			modMsgLen=sprintf(&modMsgCmd[64],modFrm->sInt,modMsgiTarget) + 64; //start printing first data which is index of recivier
			RETURN_META(MRES_IGNORED); //return me so won't be flaged as no functions to run
		}
	}
	modMsgToRun = false; //flag as no functions to run
	RETURN_META(MRES_IGNORED);
}

void CheckConditions(int len){
	modValIter++; //set position of message word in engine message (start with 1 then 2, 3, 4...)
	bool skip;cond_t*a;
	for (fun_call_t*p=modMsgHaveFun;p;p=p->next){
		if (p->done||!p->cond)continue;
		skip=true;
		for (a=p->cond;a;a=a->next){
			if (a->val!=modValIter) continue;
			skip=false;
			if (!strncmp(&modMsgCmd[modMsgLen+p->quotes],a->toval,a->tovallen)){
				skip=true;
				break;
			}
		}
		if (skip) continue;
		p->done = true;
	}
	modMsgLen+=len;
}

void MessageEnd_Post(void) {
	if (modMsgEndFunction) (*modMsgEndFunction)(NULL);
	if (modMsgHaveFun){
		if (modMsgToRun) modMsgCmd[modMsgLen-1] = '\n';
		for (fun_call_t*p=modMsgHaveFun;p;p=p->next){
			if (p->done){
				p->done = false; //unset this msg but don't call it
				continue;
			}
			if (p->fillme){
				char* todo = UTIL_FillWithVars( p->cmd );
				if ( todo && *todo ) SERVER_COMMAND( todo );
			}
			else {
				memcpy(&modMsgCmd[p->where],p->cmd,p->len);
				SERVER_COMMAND(  &modMsgCmd[p->where] );
			}
			p->stamp = gpGlobals->time; //save when last done
		}
	}
	RETURN_META(MRES_IGNORED);
}

void WriteByte_Post(int iValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&iValue);
	if (modMsgToRun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sInt,iValue));
	RETURN_META(MRES_IGNORED);
}
void WriteChar_Post(int iValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&iValue);
	if (modMsgToRun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sInt,iValue));
	RETURN_META(MRES_IGNORED);
}
void WriteShort_Post(int iValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&iValue);
	if (modMsgToRun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sInt,iValue));
	RETURN_META(MRES_IGNORED);
}
void WriteLong_Post(int iValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&iValue);
	if (modMsgToRun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sInt,iValue));
	RETURN_META(MRES_IGNORED);
}
void WriteAngle_Post(float flValue) {
	if (modMsgFunction) (*modMsgFunction)((void *)&flValue);
	if (modMsgToRun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sFloat,flValue));
	RETURN_META(MRES_IGNORED);
}
void WriteCoord_Post(float flValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&flValue);
	if (modMsgToRun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sFloat,flValue));
	RETURN_META(MRES_IGNORED);
}
void WriteString_Post(const char *sz) {
	if (modMsgFunction)	(*modMsgFunction)((void *)sz);
	if (modMsgToRun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sStr,sz));
	RETURN_META(MRES_IGNORED);
}
void WriteEntity_Post(int iValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&iValue);
	if (modMsgToRun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sInt,iValue));
	RETURN_META(MRES_IGNORED);
}

void SetModel(edict_t *e, const char *m){
	if(e->v.owner&&!strncmp(m,"models/w_h",10)){ //this entity has an owner (grenade?) and the model is from CS grenade
		int i = ENTINDEX(e->v.owner); //take index of owner (in CS this is a player who has throw the grenade)
		players[i].grenade = e; //assign grenade to player
		players[i].grenade_time = gpGlobals->time + 1.75; //and mark time
		if (players[i].wpnid > 0 && players[i].wpnid  < MAX_WEAPONS) {
			players[i].wpnstats[players[i].wpnid].shots++; //count as fired
			players[i].roundstats.shots++;
			players[i].gamestats.shots++;
			players[i].monster.shots++;
			score.gamestats[players[i].team_index].shots++;
			score.roundstats[players[i].team_index].shots++;
		}
	}
	RETURN_META(MRES_IGNORED);
}

void TraceLine(const float *v1, const float *v2, int fNoMonsters, edict_t *pentToSkip, TraceResult *ptr) {
	TRACE_LINE(v1, v2, fNoMonsters, pentToSkip, ptr);
	if (ptr->iHitgroup && pentToSkip && (pentToSkip->v.flags & IS_PLAYER))//only if we hit at something
		(GET_PLAYER_POINTER(pentToSkip))->aiming_at = ptr->iHitgroup; //save this part of body
	RETURN_META(MRES_SUPERCEDE);
}

enginefuncs_t meta_engfuncs_post;
C_DLLEXPORT int GetEngineFunctions_Post(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ) {
	meta_engfuncs_post.pfnMessageBegin = MessageBegin_Post;
	meta_engfuncs_post.pfnMessageEnd = MessageEnd_Post;
	meta_engfuncs_post.pfnWriteByte = WriteByte_Post;
	meta_engfuncs_post.pfnWriteChar = WriteChar_Post;
	meta_engfuncs_post.pfnWriteShort = WriteShort_Post;
	meta_engfuncs_post.pfnWriteLong = WriteLong_Post;
	meta_engfuncs_post.pfnWriteAngle = WriteAngle_Post;
	meta_engfuncs_post.pfnWriteCoord = WriteCoord_Post;
	meta_engfuncs_post.pfnWriteString = WriteString_Post;
	meta_engfuncs_post.pfnWriteEntity =  WriteEntity_Post;
	memcpy(pengfuncsFromEngine, &meta_engfuncs_post, sizeof(enginefuncs_t));
	return TRUE;
}

enginefuncs_t meta_engfuncs;
C_DLLEXPORT int GetEngineFunctions(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ) {
	meta_engfuncs.pfnSetModel = SetModel;
	meta_engfuncs.pfnTraceLine = TraceLine;
	memcpy(pengfuncsFromEngine, &meta_engfuncs, sizeof(enginefuncs_t));
	return TRUE;
}
