
#ifndef STATSME_H
#define STATSME_H

#include <time.h>			// time()
#include <enginecallback.h>		// ALERT()
#include <sdk_util.h>			// UTIL_VarArgs()
#include <api_info.h>
#include <string.h>

#define VDATE			"24/05/2002"
#define VVERSION		"2.5.4"
#define RC_VERS_DWORD	2,5,4,0	// Version Windows DLL Resources in res_meta.rc
#define VNAME			"STATSME"
#define VAUTHOR			"OLO"
#define VURL			"www.olo.counter-strike.pl"
#define VLOGTAG			"STATSME"
// Various strings for the Windows DLL Resources in res_plugin.rc
#define RC_COMMENTS		"STATSME"
#define RC_DESC			"STATSME - Metamod Plugin DLL"
#define RC_FILENAME		"statsme_mm.dll"
#define RC_INTERNAL		"STATSME"
#define RC_COPYRIGHT	"Copyright 2002 OLO"

#define ACCURACY_FORMULA(a,b) ((a) ? ( ((float)b * 100.00) / (float)a ) : 0.00 )// a = shots, b = hits
#define EFFEC_FORMULA(a,b) ((b + a) ? ( ((float)a * 100.00) / (float)( b + a ) ) : 0.00 )// a = kills, b = deaths

// parts of boty for hits
#define HITGROUP_GENERIC 0 // none
#define HITGROUP_HEAD 1
#define HITGROUP_CHEST 2
#define HITGROUP_STOMACH 3
#define HITGROUP_LEFTARM 4
#define HITGROUP_RIGHTARM 5
#define HITGROUP_LEFTLEG 6
#define HITGROUP_RIGHTLEG 7

// menu ids
enum MENU_TYPE{
	MENU_IDLE,			//default mode - no menu
	STATS_MENU,			//stats menu
	STATSME_MENU,		//settings menu
	MENU_STANDARD		//menu called by sm_showmenu server command
};

// delay for messages
struct task_t {
	char* cmd;
	float time;
	float repeat;
	int flags;
	task_t* next;
};

struct cond_t {
	int	val;		//position of value to check
	char* toval;	//value to compare
	int	tovallen;	//length of value to cmpare
	cond_t* next;
};

// names of commands to call
struct fun_call_t {
	char*cmd;			// commnad to execute
	bool player;		// receiver is a specified player
	bool world;			// receivers are all players
	bool done;			// does this func has been already excetued and can't be called again?
	bool once;			// keeps condition for value above
	bool fillme;		// does it should be filled with extra info?
	float stamp;		// save when this function has been called
	int len;			// length of this command
	int where;			// diffrences from 64 (my internal usage)
	int quotes;			// does this call uses quotes
	cond_t* cond;		// list of condition (filter)
	fun_call_t*next;	// next call in list
};

// stats - used by diffrent structures to store some stats - some fields may be not used in same cases
struct stat_t {
	const char*	name;	// name
	int	shots;			// number of fired bullets
	int	hits;			// hits
	int	clip;			// ammo in clip
	int	ammo;			// rest of ammo
	int	hs;				// headshots
	int	kills;			// kills
	int	tks;			// teamkilling
	int	damage;			// damage made by weapon
	int	deaths;			// deaths with this weapon
	int	hitgroup[10];	// hits in diffrent parts of body
	int	score;			// score
	int switcher;

/* It would be cool to see support for these events (just catch proper text in TextMsg)

	int plants;
	int	defuses;
	int	hostages;
	int escapes;
	int prevents;

*/

};

// well maybe it's to late for class but for futher development it may be very usefull
struct player_t {
	edict_t*	pEdict;
	int			index;			// index of player entity
	int			play_time;
	bool		valid;			// is this a bot or player
	bool		ingame;			// is this slot currently used
	char		team_name[32];
	int			team_index;
	char		ip[32];

	float		monster_time;

	stat_t		monster;				// general stats
	stat_t		gamestats;				// general stats
	stat_t		roundstats;				// round stats
	stat_t		specstats[33];			// stats which keeps attacked players (round stats)
	stat_t		wpnstats[MAX_WEAPONS];	// general weapon stats

	stat_t*		custom_stats;			// used in diffrent ways (cwpn)
	stat_t*		weapon;					// currently used weapon (wpn)
	int			aiming_at;				// chest, head, stomach etc.
	int			wpnid;					// id of currently used weapon

	player_t*	killer;				// last your killer
	player_t*	victim;				// last your victim

	int			health;
	int			armor;
	int			money;

	int			menu_id;
	MENU_TYPE	menu_type;
	int			menu_keys;
	int			menu_state;
	float		menu_time;
	int			menu_pplnum;	//number of players in menu list
	player_t*	menu_list[33];	//list of players for stats menu

	edict_t*	grenade;
	float		grenade_time;

	long int	latency_sum;
	long int	latency_samples;
	float		latency_time;

	float		stats_time;		// your attacker and victims list
	bool		stats_sent;		// determines if player has just sent the stats to rank (top15)
	bool		stats_enabled;
};

// struct which keeps misc. values for displaying on screen
struct announce_t {

	char		mod_name[32];		// name of running mod
	int			mod_id;				// it's id
	int			sm_mode;			// set statsme mode

	float		c4_timing;			// delay between counting down
	int			c4_timer;			// acctual state of c4 timer
	float		c4_planting;

	char		team_name[4][32];	// unassigned, spectator, ct (aliases), t (axis)
	int			team_num;

	player_t*	bomber;
	player_t*	defuser;
	player_t*	killer;
	player_t*	victim;
	player_t*	player;

	player_t*	best;	// keeps best result to not recalculate this same player multiple times during filling with score
	int			best_type;

	stat_t		gamestats[4];
	stat_t		roundstats[4];

	float		game_timeleft;
	float		game_restarting;

	int			stats_flags;
	float		stats_kill;
	float		stats_endround;
	float		stats_endmap;		// end map stats in motd
	int			endround_type;		// to determine for bomb success and failure defusing

	float		task_time;

	time_t		last_save;			// last eraze of rank15
};

// filled during weapon list engine message
struct wpn_sel_t {
	char name[16];			// name of the weapon when selecting it
	short int iId;			// the weapon id value
	short int ammo_slot;	//slot for ammo
};

// server rank which are displayed by top15 cmd
struct rank_t {
	char name[40];
	int points;		// points by which the rank is sort
	int	hits;		// hits taken from all weapons
	int	shots;		// shots taken from all weapons
	int	kills;		// frags
	int	deaths;		// his deaths
	int	dmg;		// overall damage done by this player
	int	tks;		// teamkilling
	int	hs;			// headshots
	float eff;		// efficiency (kills to deaths)
	float acc;		// accuracy (hits to shots)
};

#define CLIENT_PRINTF (*g_engfuncs.pfnClientPrintf)
#define GET_PLAYER_POINTER(e) &players[ENTINDEX(e)]
#define GET_PLAYER_POINTER_I(i) &players[i]

extern int	gmsgDeathMsg;
extern int	gmsgDamage;
extern int	gmsgCurWeapon;
extern int	gmsgTextMsg;
extern int	gmsgWeapPickup;
extern int	gmsgTeamInfo;
extern int	gmsgWeaponList;
extern int	gmsgResetHUD;
extern int	gmsgMOTD;
extern int	gmsgServerName;
extern int	gmsgintermission;
extern int	gmsgHealth;
extern int	gmsgBattery;
extern int  gmsgShowMenu;
extern int  gmsgSendAudio;
extern int  gmsgTeamScore;
extern int	gmsgMoney;
extern int	gmsgAmmoX;

void Client_DeathMsg(void*);
void Client_Damage(void*);
void Client_CurWeapon(void*);
void Client_TextMsg(void*);
void Client_WeapPickup(void*);
void Client_TeamInfo(void*);
void Client_WeaponList(void*);
void Client_ResetHUD(void*);
void Client_Battery(void*);
void Client_Health(void*);
void Client_SendAudio(void*);
void Client_TeamScore(void*);
void Client_ShowMenu(void*);
void Client_Money(void*);
void Client_intermission(void*);
void Client_AmmoX(void*);

extern char	modMsgCmd[512];
extern bool	modMsgActive;
extern fun_call_t* modMsgFunCalls[MAX_REG_MSGS ];
extern fun_call_t* modMsgCalledCvar;
extern int modMsgState;		//position in engine message
extern player_t* modMsgPlayer;		//target of message

#define	MOD_UNKNOW	0
#define	MOD_CSTRIKE	1

#define IS_PLAYER 8200

// keeps motd for players
struct motd_t {
	char*msg;
	motd_t*next;
};

// menu and aliases
struct action_t {
	char*name;
	char*cmd;
	int flags;
	action_t*next;
};

extern task_t*		sm_task;
extern action_t*	sm_alias;
extern action_t*	sm_menu;
extern motd_t*		sm_motd;
extern announce_t	score;
extern player_t		players[33];
extern rank_t		rank[65]; //keep stats only from first 32 players
extern wpn_sel_t	weapon_select[MAX_WEAPONS];

extern cvar_t	*statsme_version;
extern cvar_t	*sm_logformat;
extern cvar_t	*sm_knifekill;
extern cvar_t	*sm_headshot;
extern cvar_t	*sm_bombset;
extern cvar_t	*sm_bombtime;
extern cvar_t	*sm_kill;
extern cvar_t	*sm_monsterkill;
extern cvar_t	*sm_monsterkillnum;
extern cvar_t	*sm_roundend;
extern cvar_t	*sm_bombtimefreq;
extern cvar_t	*sm_bombtimecont;
extern cvar_t	*sm_bombfreq;
extern cvar_t	*sm_bombcont;
extern cvar_t	*sm_playerstats;
extern cvar_t	*sm_weaponstats;
extern cvar_t	*sm_menupassword;
extern cvar_t	*sm_monsterfreq;
extern cvar_t	*sm_bombdefused;
extern cvar_t	*sm_bombfailure;
extern cvar_t	*sm_attackers;
extern cvar_t	*sm_victims;
extern cvar_t	*sm_rankcmd;
extern cvar_t	*sm_statsmecmd;
extern cvar_t	*sm_statscmd;
extern cvar_t	*sm_killsforrank;
extern cvar_t	*sm_resetrank;
extern cvar_t	*sm_latlogformat;
extern cvar_t	*sm_latlogfreq;
extern cvar_t	*sm_switchcmd;
extern cvar_t	*sm_timelogformat;
extern cvar_t	*sm_logformat2;
extern cvar_t	*sm_attackersbody;
extern cvar_t	*sm_victimsbody;
extern cvar_t	*sm_resetonrestart;
extern cvar_t	*mp_timelimit;
extern cvar_t	*sm_roundenddelay;
extern cvar_t	*sm_logmenuaction;
//extern cvar_t	*sm_victimsdelay;

#define	STATS_ON	(1<<0)	//allow for displaying stats during the game (say /statsme)
#define SCORE_ON	(1<<1)	//show stats to all players at the end of map
#define KILL_ON		(1<<2)	//announce normal kill
#define HEAD_ON		(1<<3)	//announce headshot
#define MONSTER_ON	(1<<4)	//announce monsterkill
#define BOMB_ON		(1<<5)	//announce bomb set (only CS)
#define TIME_ON		(1<<6)	//counting down to explosion (only CS)
#define ROUND_ON	(1<<7)	//round end score (only CS)
#define TOP_ON		(1<<8)	//top15 list
#define BDWS_ON		(1<<9)	//bomb succesfully defused (only CS)
#define BDF_ON		(1<<10) //bomb defusing failure (only CS)
#define STAB_ON		(1<<11) //killing by knife (how far supports only "knife" weapon)
#define AL_ON		(1<<12) //attackers list
#define VL_ON		(1<<13) //victims list

#define SM_MODE(a) ( ( score.sm_mode & a ) != 0 )

#define KNIFE_KILL		(1<<0)
#define TEAM_KILL		(1<<1)
#define HS_KILL			(1<<2)
#define GRENADE_KILL	(1<<3)
#define ROUND_END		(1<<4)

void statsme_init(void);
void UTIL_ShowMOTD( edict_t *client , char *pList, const char *szName);
void UTIL_HudMessage(const hudtextparms_t &textparms, char *pMessage, edict_t *pEntity);
void UTIL_ClientPrintMsgAll( int msg_dest,  char *fmt, ... );
void UTIL_ClientPrint( edict_t *pEntity, int msg_dest, char *fmt, ... );
void UTIL_IntToString(int value, char *output);
char* UTIL_FillWithVars(const char* src);
void StatsMenu(player_t *pPlayer, int state);
void StatsMeMenu(player_t *pPlayer, int state);
void CmdSay(void);
void CmdTell(void);
void CmdAlias(void);
void CmdClExec(void);
void CmdMotd(void);
void CmdLog(void);
void AddPlayerToRank(player_t* pPlayer);
void ShowTopScore(player_t* pPlayer);
void TASK_COMMAND(char* cmd, float time,int flags);
player_t * GetBestPlayer(int option, const char* team );
const char* GetPlayerValue(player_t *pPlayer, const char* src);
char* GetFightList(player_t *pPlayer, bool attackers);
void CmdShowMenu(void);
void UTIL_ServerShowMenu( player_t *pPlayer, const char *sMenu, const char *slots , int menuid, int displaytime);

struct fun_me_t{
	void (*modMsgFunction)(void*);
};

extern fun_me_t modMsgs[MAX_REG_MSGS];
extern fun_me_t modMsgEnds[MAX_REG_MSGS ];

#endif // STATSME_H
