
#include <extdll.h>			// always
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <cbase.h>			// DMG bits
#include "statsme.h"	// me

//struct keeping names and indexes for weapons
wpn_sel_t weapon_select[MAX_WEAPONS];

void Client_SendAudio(void* MsgValue){

	if (modMsgPlayer)
		return; //accept only global sounds

	static const char *szSound;

	switch (modMsgState++) {
	case 1:
		szSound = (char*)MsgValue;

		if (!strcmp(szSound,"%!MRAD_BOMBPL")) // "The bomb has been planted!"
		{
			if ( score.c4_planting > gpGlobals->time ) //don't allow to announce bomb planting after round end
				break;

			if ( SM_MODE(TIME_ON) )
				score.c4_timer = CVAR_GET_FLOAT("mp_c4timer") + 1;

			if ( SM_MODE(BOMB_ON) && *sm_bombset->string)
				SERVER_COMMAND(UTIL_FillWithVars(sm_bombset->string));

		}
		else if (!strcmp(szSound,"%!MRAD_BOMBDEF")) // "The bomb has been defused!"
		{
			score.endround_type = 1;
		}
		else if ( !strcmp(szSound,"%!MRAD_terwin" )||!strcmp( szSound,"%!MRAD_ctwin" )||!strcmp( szSound,"%!MRAD_rounddraw" ))
		{
			score.stats_flags |= ROUND_END;
			score.c4_planting = gpGlobals->time + 6.0; //protect yourself from ablity of planting bomb just after round end
			score.c4_timer = 0; //stop bomb counting down because the round has already finished
			score.stats_endround = gpGlobals->time + 0.05; //and show end stats
		}
	}
}

//Score teams
void Client_TeamScore(void* MsgValue)
{
	static const char *szTeam;

	switch (modMsgState++) {
	case 0:
		szTeam = (char*)MsgValue;
		break;
	case 1:

		for(int i = 0 ; i < score.team_num; ++i)
		{
			if ( !strcmpi( szTeam, score.team_name[i] ) )
			{
				score.gamestats[i].score = score.roundstats[i].score = *(int*)MsgValue;

				break;
			}
		}
	}
}

//msg send when text is send to client or all players
void Client_TextMsg(void* MsgValue) {

	static char* sText;

	switch (modMsgState++) {
	case 1:
		sText = (char*)MsgValue;

		if (modMsgPlayer) //msg to specified players
		{
			if (!strncmp("#Defusing_Bomb",sText,14)) // "Defusing bomb ..." - save who defuses the bomb
				score.defuser = modMsgPlayer;
		}
		else { //global msg

			if ( !strncmp("#Target_B",sText,9) )
			{
				score.endround_type = 2; // "Target Succesfully Bombed!"
			}
			else if ( !strncmp("#Game_C",sText, 7) ) //  "Game Commencing!"
			{
				score.game_timeleft = score.game_restarting = gpGlobals->time + 3.0;
			}
			else if (!strncmp("#Game_w",sText, 7) ) // "The game will restart in ..."
			{
				score.game_timeleft = -2;
			}

		}
		break;
	case 2:

		if (score.game_timeleft == -2)
		{
			score.game_timeleft = score.game_restarting = gpGlobals->time + atoi( (char*)MsgValue );
		}

		break;
	}

}

// msg send on player respawn/spawn - used to determine new round in CS
void Client_ResetHUD(void* MsgValue)
{
	memset(&modMsgPlayer->roundstats,0,sizeof(modMsgPlayer->roundstats));
	memset(modMsgPlayer->specstats,0,sizeof(modMsgPlayer->specstats));

	modMsgPlayer->killer = NULL;
	modMsgPlayer->victim = NULL;
	modMsgPlayer->stats_time = 0;
}

// when player's team is changed then this msg is send to player
void Client_TeamInfo(void* MsgValue)
{	
	if (modMsgPlayer)
		return;

	static int index;
	static const char* team;
	switch (modMsgState++) {
	case 0:
		index = *(int*)MsgValue;
		break;
	case 1:

		team = (char*)MsgValue;

		// allow as first save "unassigned" as natural 0
		int i;for(i = 0; i < score.team_num ; ++i)
			if ( !strcmpi(score.team_name[i],team) )
				break;

		//accept only new teams, there is only max 4 teams and we don't like "spectator"
		if (i == score.team_num && i < 4 && strcmpi(team, "spectator" ) ) 
			strcpy( score.team_name[score.team_num++], team);
		
		strcpy(players[index].team_name,team); //save name of team
		players[index].index = index;
		players[index].team_index = i;
		players[index].pEdict = INDEXENT(index); // bots doesn't always pass through PutInServer(...)
		players[index].ingame = true; //that is why we must set player status again - just in case
	}
}

// msg send when player requests list of weapons from server
void Client_WeaponList(void* MsgValue)
{
	static int wpnList;
	static int iId;
	static int iSlot;
	static const char* wpn_name;	
	
	switch (modMsgState++) {
	case 0:
		wpn_name = (char*)MsgValue;
		break;
	case 1:
		iSlot = *(int*)MsgValue;
		break;
	case 7:
		iId = *(int*)MsgValue;

		if ( iId < MAX_WEAPONS && wpnList & (1<<iId) ) //check if weapon is not already listed
			break;

		wpnList |= (1<<iId);

		weapon_select[iId].iId = iId;
		weapon_select[iId].ammo_slot = iSlot;
		strcpy(weapon_select[iId].name, wpn_name + 7 ); //trunk "weapon_" from weapon name
	}	
}

// message gets sent when the players ammo changes
void Client_AmmoX(void* MsgValue)
{
	static int iAmmo;
	switch (modMsgState++){
	case 0:

		iAmmo = *(int*)MsgValue;

		break;
	case 1:
		for(int i=0; i < MAX_WEAPONS ; ++i)
		{
			if (iAmmo == weapon_select[i].ammo_slot)
				modMsgPlayer->wpnstats[i].ammo = *(int*)MsgValue;
		}
	}
}

// msg send to update current status about weapon - ammo, active weapon etc
void Client_CurWeapon(void* MsgValue)
{
	static int iState;
	static int iClip;
	static int iId;

	switch (modMsgState++){
	case 0:	

		iState = *(int*)MsgValue;

		break;
	case 1:	

		if (iState) //active weapon have iState set to 1
		{
			modMsgPlayer->wpnid = iId = *(int*)MsgValue; // weapon ID
		}

		break;
	case 2:

		if (!iState) break;
		
		iClip = *(int*)MsgValue;
		
		if (iClip > -1 && iClip < modMsgPlayer->wpnstats[iId].clip) //shots are only on decrease
		{
			modMsgPlayer->wpnstats[iId].shots++;
			//modMsgPlayer->specstats[???].shots++; //any ideas - it would be cool to know with what acc. you have been killed :)
			modMsgPlayer->roundstats.shots++;
			modMsgPlayer->gamestats.shots++;
			modMsgPlayer->monster.shots++;
			
			score.gamestats[modMsgPlayer->team_index].shots++;
			score.roundstats[modMsgPlayer->team_index].shots++;
		}
		
		modMsgPlayer->weapon = &modMsgPlayer->wpnstats[iId];
		modMsgPlayer->weapon->name = weapon_select[iId].name; //save name of this weapon
		modMsgPlayer->wpnstats[iId].clip = iClip;
	}
}

// message about death (top-right corner)
void Client_DeathMsg(void* MsgValue)
{	
	static char* sWpn;
	static int kid;
	static int vid;
	static player_t *killer;
	static player_t *victim;
	static bool	hs;
	
	switch (modMsgState++){
	case 0:

		kid = *(int*)MsgValue;
		killer = score.killer = GET_PLAYER_POINTER_I(kid);

		break;
	case 1:

		vid = *(int*)MsgValue;
		victim = score.victim = GET_PLAYER_POINTER_I(vid);

		break;
	case 2:	

		hs = ( *(int*)MsgValue ) ? true : false ;
		
		break;
	case 3:
		//only if attacker and victim are valid and it's not the same player
		if ( killer == victim || !killer || !victim )
			break;

		sWpn = (char*)MsgValue;

		score.stats_flags = 0;

		if ( sWpn[0]=='g' && sWpn[1]=='r' && sWpn[2]=='e' ) //this is "grenade"
		{
			score.stats_flags |= GRENADE_KILL;

			sWpn = "hegrenade"; //name not matches so fix it

		}
		else if ( !strcmp( sWpn, "knife" ) )
		{
			score.stats_flags |= KNIFE_KILL; //set bit flag for kill announce (knife)
		}

		int diffteam = strcmp(killer->team_name, victim->team_name);

		for (int i = 0; i < MAX_WEAPONS ; ++i)
		{
			if ( !strcmp( sWpn, weapon_select[i].name ) )
			{
				killer->specstats[vid].name = weapon_select[i].name; //save name of weapon from which you have been killed
				killer->custom_stats = &killer->specstats[vid];
				victim->custom_stats = &victim->specstats[kid];
				killer->victim = victim;
				victim->killer = killer;

				
				if (hs) { //headshot

					score.stats_flags |= HS_KILL; //set bit flag for kill announce (headshot)

					killer->gamestats.hs++; // game normal score
					killer->roundstats.hs++; // round normal score
					killer->wpnstats[i].hs++; //save in weapon stats
					killer->specstats[vid].hs++; //in round detailed stats

					score.gamestats[killer->team_index].hs++; //game team score
					score.roundstats[killer->team_index].hs++; //round team score
				}
				
				killer->wpnstats[i].kills++;
				killer->specstats[vid].kills++;
				killer->roundstats.kills++;
				killer->gamestats.kills++;

				score.gamestats[killer->team_index].kills++;
				score.roundstats[killer->team_index].kills++;

				victim->wpnstats[i].deaths++;
				victim->specstats[vid].deaths++; //round detailed
				victim->roundstats.deaths++;
				victim->gamestats.deaths++;

				score.gamestats[victim->team_index].deaths++;
				score.roundstats[victim->team_index].deaths++;

				if (!diffteam) //team killing
				{
					score.stats_flags |= TEAM_KILL;

					killer->wpnstats[i].tks++;
					killer->specstats[vid].tks++; //round detailed
					killer->roundstats.tks++;
					killer->gamestats.tks++;

					score.gamestats[killer->team_index].tks++;
					score.roundstats[killer->team_index].tks++;
				}
				else {

					if (killer->monster_time < gpGlobals->time)
						memset(&killer->monster,0,sizeof(killer->monster));

					killer->monster_time = gpGlobals->time + sm_monsterfreq->value;

					if (hs)	
						killer->monster.hs++;

					killer->monster.kills++;
				}
								
				// announce who was your attacker and who you have attacked
				victim->stats_time = gpGlobals->time + 0.05;

				// announce hs kill etc.
				score.stats_kill = gpGlobals->time + 0.05;

				break; //Nothing else to do here
			}
		}
	}
}

// message send when player takes damage
void Client_Damage(void* MsgValue)
{
	static int damage;
	static int kid;
	static int vid;
	static edict_t *enemy; 
	static player_t *killer; 

	switch (modMsgState++) {
	case 1:	
		damage = *(int*)MsgValue;
		break;
	case 2:
		if (!damage) break; //no damage

		enemy = modMsgPlayer->pEdict->v.dmg_inflictor;

		if (!enemy) break; //no enemy

		vid = modMsgPlayer->index;

		score.victim = modMsgPlayer;
			
		if (enemy->v.flags & IS_PLAYER) { // player
			kid = ENTINDEX(enemy);
			killer = GET_PLAYER_POINTER_I(kid);
			if ( killer->wpnid > 0 && killer->wpnid  < MAX_WEAPONS ){
				killer->wpnstats[killer->wpnid].damage += damage;
				killer->wpnstats[killer->wpnid].hits++;
				killer->wpnstats[killer->wpnid].hitgroup[killer->aiming_at]++;
			}
		}
		else if(!strcmp(STRING(enemy->v.classname),"grenade"))	{ //grenade (only CS)
			for (kid = 1; kid <= gpGlobals->maxClients; ++kid) {
				if ( enemy == players[kid].grenade && players[kid].grenade_time > gpGlobals->time ){
					killer = GET_PLAYER_POINTER_I(kid);
					killer->wpnstats[4].damage += damage;
					killer->wpnstats[4].hits++;
					break;
				}
			}
		}
		else
			break; //not grenade and not player so skip it
				
		if (kid > 0 && kid < 33) {//if this is a player
			killer->specstats[vid].damage += damage;
			killer->specstats[vid].hits++;
			killer->specstats[vid].hitgroup[killer->aiming_at]++;
			
			killer->roundstats.damage += damage;
			killer->roundstats.hits++;
			killer->roundstats.hitgroup[killer->aiming_at]++;
			
			killer->gamestats.damage += damage;
			killer->gamestats.hits++;
			killer->gamestats.hitgroup[killer->aiming_at]++;
			
			score.gamestats[killer->team_index].damage += damage;
			score.gamestats[killer->team_index].hits++;
			score.gamestats[killer->team_index].hitgroup[killer->aiming_at]++;
			
			score.roundstats[killer->team_index].damage += damage;
			score.roundstats[killer->team_index].hits++;
			score.roundstats[killer->team_index].hitgroup[killer->aiming_at]++;

			killer->monster.damage += damage;
			killer->monster.hits++;
			killer->monster.hitgroup[killer->aiming_at]++;

			score.killer = killer;
		}
	}
}

void Client_ShowMenu(void* MsgValue) 
{
	modMsgPlayer->menu_type = MENU_IDLE; //set by default that we have no menu 
	// if this is SM menu then it will be set again after it by function building menu
}

void Client_intermission(void* MsgValue)
{
	score.stats_endmap = gpGlobals->time + 2.0; //intermission - give some delay before displaying end stats for all ppl
}

// msg send on weapon pickup
void Client_WeapPickup(void* MsgValue)
{
	if (*(int*)MsgValue == 6) //6 is an ID of C4 and save this person as potentional bomb planter
		score.bomber = modMsgPlayer;
}

// message gets sent when the players health changes
void Client_Health(void* MsgValue)
{
	modMsgPlayer->health = *(int*)MsgValue;  // health ammount
}

// message gets sent when the players armor changes
void Client_Battery(void* MsgValue)
{
	modMsgPlayer->armor = *(int*)MsgValue;  // armor ammount
}

// money - second value says if the money change should flash on hud or not
void Client_Money(void* MsgValue)
{
	switch (modMsgState++){
	case 0:
		modMsgPlayer->money = *(int*)MsgValue;
	}
}

