
#include <extdll.h>			// always
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <time.h>
#include "statsme.h"	// me

rank_t rank[65]; //rank of players

void UTIL_Pathname_Convert(char *pth) {
	while (pth && *pth) {
#ifndef __linux__
		if (*pth == '/') *pth = '\\'; // convert to MS-DOS format 
#else
		if (*pth == '\\') *pth = '/'; // convert to Linux format
#endif
		++pth;
	}
}

inline void swap(rank_t& a, rank_t& b) {
	rank_t c=a; a=b; b=c;
}

void sortrank(rank_t *table,int left,int right) {
	if (left < right) {
		int m=left;
		for(int i=left+1;i<=right;i++)
			if (table[i].points>table[left].points)
				swap(table[++m],table[i]);
		swap(table[left],table[m]);
		sortrank(table,left,m-1);
		sortrank(table,m+1,right);
	}
}

// used to set points for rank - set here your own rules for scoring the player
void givepoints(rank_t*pos) {
	pos->points = (int)(pos->eff) + (int)pos->acc + ((int)(pos->hs)/5);
	if (pos->kills < (int)sm_killsforrank->value) pos->points /= 2;
}

void AddPlayerToRank(player_t* pPlayer)
{
	if (!pPlayer->valid) return; //skip bots
	const char* nick = STRING(pPlayer->pEdict->v.netname);
	int a;for (a = 0; a < 64; ++a) { //if already exists then add score to this existing one
		if (!strncmp(nick,rank[a].name,32))
			break;
	}
	if (a == 64) { //doesn't exists - so clear last slot and add him there
		memset(&rank[a],0,sizeof(rank_t));
		strncpy(rank[a].name,nick,32);
	}
	rank[a].tks += pPlayer->gamestats.tks;
	rank[a].dmg += pPlayer->gamestats.damage;
	rank[a].deaths += pPlayer->gamestats.deaths;
	rank[a].kills += pPlayer->gamestats.kills;
	rank[a].shots += pPlayer->gamestats.shots;
	rank[a].hits += pPlayer->gamestats.hits;
	rank[a].hs += pPlayer->gamestats.hs;
	rank[a].acc = ACCURACY_FORMULA(pPlayer->gamestats.shots,pPlayer->gamestats.hits);
	rank[a].eff = EFFEC_FORMULA(pPlayer->gamestats.kills,pPlayer->gamestats.deaths);
	givepoints(&rank[a]);
	sortrank(rank,0,64);
}

void ShowTopScore(player_t* pPlayer)
{
	static char besthall[2048];
	static char *spaces = "....................................."; //used to format rank list
//	int len=sprintf(besthall,"#  nick                     kills/deaths   hits/shots/hs.   eff.%%   acc.%%   pt.\n");
	int len=sprintf(besthall,"#  nick                     kills/deaths   hits/shots/hs.   eff.%%   acc.%%\n");
	for (int i = 0; i < 15 && rank[i].name[0] ; ++i) {
//		len+=sprintf(&besthall[len], UTIL_VarArgs("%d. %s%s%d/%d   %d/%d/%d   %.2f   %.2f  %d\n",
//			i + 1, rank[i].name, spaces+(int)(strlen(rank[i].name)*1.6), rank[i].kills , 
//			rank[i].deaths,rank[i].hits, rank[i].shots,rank[i].hs,  rank[i].eff, rank[i].acc, rank[i].points));
		len+=sprintf(&besthall[len], UTIL_VarArgs("%d. %s%s%d/%d   %d/%d/%d   %.2f   %.2f\n",
			i + 1, rank[i].name, spaces+(int)(strlen(rank[i].name)*1.6), rank[i].kills , 
			rank[i].deaths,rank[i].hits, rank[i].shots,rank[i].hs,  rank[i].eff, rank[i].acc));
	}
	UTIL_ShowMOTD(pPlayer->pEdict,besthall, "Top 15");
}